package com.godmonth.util;

import java.util.Date;
import java.util.concurrent.Executors;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class PressureLifeCycle {

	protected Logger logger = LoggerFactory.getLogger(getClass());
	protected int threadNum;
	protected ThreadPoolExecutor executorService;
	protected Date startTime;

	public void deactive() {
		if (executorService != null) {
			executorService.shutdownNow();
			while (true) {
				try {
					executorService.awaitTermination(5, TimeUnit.SECONDS);
					break;
				} catch (Exception e) {
				}
			}

		}

	}

	protected void ready() {
		if (executorService == null) {
			executorService = (ThreadPoolExecutor) Executors
					.newCachedThreadPool();
		}
		startTime = new Date();
	}

	public void active() {
		ready();
		for (int i = 0; i < threadNum; i++) {
			executorService.execute(triggerJob());
		}

	}

	protected Runnable triggerJob() {
		return null;
	}

	public int getThreadNum() {
		return threadNum;
	}

	public void setThreadNum(int threadNum) {
		this.threadNum = threadNum;
	}

	public Date getStartTime() {
		return startTime;
	}

}
