package com.godmonth.util.ehcache;

import java.util.List;

import org.apache.commons.lang.Validate;
import org.springframework.beans.factory.InitializingBean;

import net.sf.ehcache.Ehcache;

public class EhcacheMemoryManuallyCleaner implements Runnable, InitializingBean {
	private List<Ehcache> ehcaches;
	private int interval;

	public void afterPropertiesSet() throws Exception {
		Validate.notEmpty(ehcaches);
		Validate.isTrue(interval > 0);
	}

	private int i;

	public void run() {

		while (true) {
			ehcaches.get(i++ % ehcaches.size()).evictExpiredElements();
			try {
				Thread.sleep(interval);
			} catch (InterruptedException e) {
			}
		}
	}

	public void setEhcaches(List<Ehcache> ehcaches) {
		this.ehcaches = ehcaches;
	}

	public void setInterval(int interval) {
		this.interval = interval;
	}

	public int getInterval() {
		return interval;
	}

}
